#line 1 "F:/MikroC/ModbusSlave/ModbusSlave.c"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/built_in.h"
#line 1 "f:/mikroc/modbusslave/modbusslave.h"
#line 1 "f:/mikroc/modbusslave/types.h"
#line 14 "f:/mikroc/modbusslave/types.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;
#line 41 "f:/mikroc/modbusslave/modbusslave.h"
 typedef struct {
 byte bytHi;
 byte bytLo;
 } hiloDef;

 typedef enum eBaudRates {
 BAUD_1200 = 12,
 BAUD_2400 = 24,
 BAUD_4800 = 48,
 BAUD_9600 = 96,
 BAUD_19200 = 192,
 BAUD_38400 = 384,
 BAUD_57600 = 576,
 BAUD_115200 = 1152
 } baudRate;

 typedef enum eModbusFunctions {
 READ_COILS = 1,
 READ_STATUS_INPUTS = 2,
 READ_HOLDING_REGISTERS = 3,
 READ_INPUT_REGISTERS = 4,
 FORCE_SINGLE_COIL = 5,
 PRESET_SINGLE_REGISTER = 6,
 FORCE_MULTIPLE_COILS = 15,
 PRESET_MULTIPLE_REGISTERS = 16
 } mbFunction;

 typedef enum eModbusExceptions {
 NO_EXCEPTION = 0,
 ILLEGAL_FUNCTION = 1,
 ILLEGAL_DATA_ADDRESS = 2,
 ILLEGAL_DATA_VALUE = 3,
 SLAVE_DEVICE_FAILURE = 4,
 ACKNOWLEDGE = 5,
 SLAVE_DEVICE_BUSY = 6,
 NEGATIVE_ACKNOWLEDGE = 7,
 MEMORY_PARITY_ERROR = 8
 } mbException;

 typedef struct _discrete {

 uint uintAddress;

 ushort* pByte;

 byte bBit;

 struct _discrete* pNext;
 } discreteDef;

 typedef discreteDef coilDef;
 typedef discreteDef statusDef;


 typedef struct {
 byte bytSlave;
 byte bytFunction;
 hiloDef addr;
 hiloDef points;
 hiloDef crc;
 } reqDataDef;

 typedef reqDataDef reqCoilsDef;
 typedef reqDataDef reqStatusDef;
 typedef reqDataDef reqHoldReqDef;
 typedef reqDataDef reqInputsDef;

 typedef struct _register {

 uint uintAddress;

 union {
 byte* pLoHi[2];
 uint* pBase;
 } mapping;

 struct _register* pNext;
 } registerDef;

 typedef registerDef inputDef;
 typedef registerDef holdingDef;

 boolean addCoil(coilDef* pCoil,
 uint uintAddress, ushort* pByte, byte bBit);
 boolean addHoldingReg(holdingDef* pHolding,
 uint uintAddress, byte bytMapping, uint* pWord);
 boolean addInputReg(inputDef* pInput,
 uint uintAddress, byte bytMapping, uint* pWord);
 boolean addStatusBit(statusDef* pStatus,
 uint uintAddress, ushort* pByte, byte bBit);
 void decodePacket(void);
 int modbusSlave(baudRate eBaud, const byte bytAddress,
 const byte bytStopBits);

 extern sfr sbit Tx_dir;
#line 42 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static coilDef* pLastCoil =  ((void*)0) ;
static statusDef* pLastStatusBit =  ((void*)0) ;
static inputDef* pLastInput =  ((void*)0) ;
static holdingDef* pLastHoldingReg =  ((void*)0) ;

static coilDef* pCoils =  ((void*)0) ;
static statusDef* pStatusBits =  ((void*)0) ;
static inputDef* pInputs =  ((void*)0) ;
static holdingDef* pHoldingRegs =  ((void*)0) ;

static boolean blnValidStart, blnValidEnd;

static mbException exceptionCode;

static byte bytSlaveAddress;

static byte bytStartHi, bytStartLo;

static byte bytTotalHi, bytTotalLo;

static byte bytIndex = 0;

static uint uintRxGapSetPt1;
static uint uintRxGapSetPt2;
static uint uintRxGapSetPt3;
static uint uintRxGapSetPt;

static uint uintRxGap;

static byte aryBuffer[ 256 ];
static byte bytRxphase;

sbit Tx_dir at LATE.B0;
#line 90 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static boolean addDiscrete(discreteDef* pDiscrete,
 uint uintAddress,
 ushort* pByte, byte bBit,
 discreteDef** pLinkList,
 discreteDef** pLast) {
 if ( !(pDiscrete && uintAddress && pByte &&
 bBit >= 0 && bBit < 8 && pLinkList && pLast) ) {
 return FALSE;
 }
 if ( *pLinkList ==  ((void*)0)  ) {

 *pLinkList = *pLast = pDiscrete;
 } else {

 (*pLast)->pNext = pDiscrete;

 *pLast = pDiscrete;
 }

 pDiscrete->uintAddress = uintAddress;
 pDiscrete->pByte = pByte;
 pDiscrete->bBit = bBit;
 pDiscrete->pNext =  ((void*)0) ;
}
#line 135 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static boolean addRegister(registerDef* pRegister,
 uint uintAddress,
 byte bytMapping,
 uint* pWord,
 registerDef** pLinkList,
 registerDef** pLast) {
 if ( !(pRegister && uintAddress && pWord && pLinkList && pLast &&
 (bytMapping == 0 || bytMapping == 1)) ) {
 return FALSE;
 }

 if ( pRegister->uintAddress == uintAddress ) {

 if ( (bytMapping == 0 && pRegister->mapping.pBase !=  ((void*)0) ) ||
 (bytMapping == 1 && pRegister->mapping.pLoHi[1] !=  ((void*)0) ) ) {

 return FALSE;
 }
 } else {

 if ( *pLinkList ==  ((void*)0)  ) {

 *pLinkList = *pLast = pRegister;
 } else {

 (*pLast)->pNext = pRegister;

 *pLast = pRegister;
 }

 pRegister->uintAddress = uintAddress;
 pRegister->pNext =  ((void*)0) ;
 }
 if ( bytMapping == 0 ) {
 pRegister->mapping.pBase = pWord;
 } else {
 pRegister->mapping.pLoHi[1] = (byte*)pWord;
 }
}
#line 184 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static long calcCRC(uint uintLength) {
 long lngCRC = 0xffff;
 uint i, j;
 for( i=0; i<uintLength; i++ ) {
 lngCRC ^= (aryBuffer[i] & 0xff);

 for( j=0; j<8; j++ ) {
 if ( lngCRC & 0x01 ) {
 lngCRC >>= 0x01;
 lngCRC ^= 0xa001;
 } else {
 lngCRC >>= 0x01;
 }
 }
 }
 return lngCRC;
}
#line 212 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static void coilState(uint uintAddr, boolean eState) {

 discreteDef* pNode;
 byte bytMask;
 for( pNode=pCoils; pNode!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( pNode->uintAddress != uintAddr ) {
 continue;
 }
 bytMask = (1 << pNode->bBit);

 if ( eState == TRUE ) {

 *pNode->pByte |= bytMask;
 } else {

 *pNode->pByte &= (0xffff ^ bytMask);
 }
 break;
 }
}
#line 245 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static uint packBits(discreteDef* pLL, byte* pBuffer,
 uint uintStart, uint uintEnd) {

 uint uintBytes = 0, uintBit = 0;
 discreteDef* pNode;
 byte bytSet;
 for( pNode=pLL; pNode!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( pNode->uintAddress >= uintStart && pNode->uintAddress <= uintEnd ) {
 bytSet = (*pNode->pByte & (1 << pNode->bBit)) ? 1 : 0;

 if ( bytSet ) {
 pBuffer[uintBytes] |= (bytSet << uintBit);
 }
 if ( ++uintBit > 7 ) {
 uintBit = 0;
 uintBytes++;
 }
 }
 }
 return uintBytes + 1;
}
#line 279 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static uint packRegisters(registerDef* pLL, byte* pBuffer,
 uint uintStart, uint uintEnd) {

 uint uintBytes = 0;
 registerDef* pNode;
 for( pNode=pLL; pNode!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( pNode->uintAddress >= uintStart && pNode->uintAddress <= uintEnd ) {
 if ( pNode->mapping.pLoHi[1] !=  ((void*)0)  ) {
 pBuffer[uintBytes++] = *pNode->mapping.pLoHi[1];
 pBuffer[uintBytes++] = *pNode->mapping.pLoHi[0];
 } else {
 pBuffer[uintBytes++] = (*pNode->mapping.pBase >> 0x08);
 pBuffer[uintBytes++] = (*pNode->mapping.pBase & 0xff);
 }
 }
 }
 return uintBytes;
}
#line 308 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static void setRegister(uint uintAddr, uint* pData) {

 registerDef* pNode;
 uint uintTemp;
 uintTemp = *pData;
 for( pNode=pHoldingRegs; pNode!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( pNode->uintAddress != uintAddr ) {
 continue;
 }
 if ( pNode->mapping.pLoHi[1] !=  ((void*)0)  ) {
 *pNode->mapping.pLoHi[0] =  ((char *)&uintTemp)[1] ;
 *pNode->mapping.pLoHi[1] =  ((char *)&uintTemp)[0] ;
 } else {
 *pNode->mapping.pBase = uintTemp;
 }
 break;
 }
}
#line 336 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static void startTimeout(void) {

 TMR0ON_bit = 0;

 if ( bytRxphase.B1 ) {
 TMR0H =  ((char *)&uintRxGapSetPt3)[1] ;
 TMR0L =  ((char *)&uintRxGapSetPt3)[0] ;
 } else if ( bytRxphase.B2 ) {
 TMR0H =  ((char *)&uintRxGapSetPt2)[1] ;
 TMR0L =  ((char *)&uintRxGapSetPt2)[0] ;
 } else if ( bytRxphase.B7 ) {
 TMR0H =  ((char *)&uintRxGapSetPt1)[1] ;
 TMR0L =  ((char *)&uintRxGapSetPt1)[0] ;
 } else {
 TMR0H =  ((char *)&uintRxGapSetPt)[1] ;
 TMR0L =  ((char *)&uintRxGapSetPt)[0] ;
 }

 TMR0IF_bit = 0;

 TMR0ON_bit = 1;
}
#line 368 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static void restartRx(void) {

 bytRxphase = RCREG;
 bytRxphase = RCREG;

 CREN_bit = 0;
 CREN_bit = 1;

 Tx_dir = 0;





 bytRxphase = 0;
 bytIndex = 0;

 TXEN_bit = 0;
 TXIE_bit = 0;

 RCIE_bit = 1;
 startTimeout();
}
#line 403 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static boolean validAddresses(uint uintAddress, uint uintStart, uint uintEnd) {
 if ( blnValidStart == FALSE && uintStart == uintAddress ) {
 blnValidStart = TRUE;
 }
 if ( blnValidEnd == FALSE && uintEnd == uintAddress ) {
 blnValidEnd = TRUE;
 }
 return (blnValidStart == TRUE && blnValidEnd == TRUE);
}
#line 424 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static boolean validDiscretes(discreteDef* pLL, uint uintStart, uint uintEnd) {
 discreteDef* pNode;
 blnValidStart = blnValidEnd = FALSE;
 for( pNode=pLL; pNode!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( validAddresses(pNode->uintAddress, uintStart, uintEnd) == TRUE ) {
 return TRUE;
 }
 }
 return FALSE;
}
#line 446 "F:/MikroC/ModbusSlave/ModbusSlave.c"
static boolean validRegisters(registerDef* pLL, uint uintStart, uint uintEnd) {
 registerDef* pNode;
 blnValidStart = blnValidEnd = FALSE;
 for( pNode=pLL; pNode!= ((void*)0) ; pNode=pNode->pNext ) {
 if ( validAddresses(pNode->uintAddress, uintStart, uintEnd) == TRUE ) {
 return TRUE;
 }
 }
 return FALSE;
}
#line 469 "F:/MikroC/ModbusSlave/ModbusSlave.c"
boolean addCoil(coilDef* pCoil, uint uintAddress, ushort* pByte, byte bBit) {
 return addDiscrete(pCoil, uintAddress, pByte, bBit, &pCoils, &pLastCoil);
}
#line 485 "F:/MikroC/ModbusSlave/ModbusSlave.c"
boolean addHoldingReg(holdingDef* pHolding, uint uintAddress, byte bytMapping,
 uint* pWord) {
 return addRegister(pHolding, uintAddress, bytMapping, pWord, &pHoldingRegs,
 &pLastHoldingReg);
}
#line 503 "F:/MikroC/ModbusSlave/ModbusSlave.c"
boolean addInputReg(inputDef* pInput, uint uintAddress, byte bytMapping,
 uint* pWord) {
 return addRegister(pInput, uintAddress, bytMapping, pWord, &pInputs,
 &pLastInput);
}
#line 521 "F:/MikroC/ModbusSlave/ModbusSlave.c"
boolean addStatusBit(statusDef* pStatus, uint uintAddress, ushort* pByte,
 byte bBit) {
 return addDiscrete(pStatus, uintAddress, pByte, bBit, &pStatusBits,
 &pLastStatusBit);
}
#line 536 "F:/MikroC/ModbusSlave/ModbusSlave.c"
void decodePacket(void) {
 uint uintCRCpos, uintCRC;

 if ( TMR0IF_bit ) {
 bytRxphase.B0 = 1;
 TMR0ON_bit = 0;

 TMR0IF_bit = 0;

 if ( bytRxphase.B7 ) {

 restartRx();
 return;
 }
 }
 if( RCIF_bit ) {
 byte bytTemp;

 if ( OERR_bit || FERR_bit ) {
 restartRx();
 return;
 }


 bytTemp = RCREG;


 if ( bytRxphase == 0 || bytRxphase.B2 == 1 ||
 bytIndex >=  256  ) {

 bytIndex = 0;
 bytRxphase = 0;
 startTimeout();
 return;
 }
 if ( bytIndex == 0) {

 bytRxphase = 2;
 }

 aryBuffer[bytIndex++] = bytTemp;

 startTimeout();
 } else if ( bytRxphase.B7 ) {
 if ( TXIF_bit ) {
 if ( bytIndex < aryBuffer[0] ) {
 TXREG=aryBuffer[bytIndex++];
 } else {

 startTimeout();

 TXIE_bit = 0;
 }
 return;
 }
 }
 if ( bytRxphase == 3 ) {

 bytRxphase = 4;
 startTimeout();
 }
 if ( bytRxphase != 5 ) {

 return;
 }

 if (aryBuffer[0] == bytSlaveAddress ) {

 uintCRCpos = 6;

 switch( aryBuffer[1] ) {
 case READ_COILS:
 case FORCE_SINGLE_COIL:
 case FORCE_MULTIPLE_COILS:
 if ( pCoils ==  ((void*)0)  ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 }
 break;
 case READ_STATUS_INPUTS:
 if ( pStatusBits ==  ((void*)0)  ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 }
 break;
 case READ_HOLDING_REGISTERS:
 case PRESET_SINGLE_REGISTER:
 case PRESET_MULTIPLE_REGISTERS:
 if ( pHoldingRegs ==  ((void*)0)  ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 }
 break;
 case READ_INPUT_REGISTERS:
 if ( pInputs ==  ((void*)0)  ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 }
 break;
 default:

 exceptionCode = ILLEGAL_FUNCTION;
 break;
 }
 bytStartHi = aryBuffer[2];
 bytStartLo = aryBuffer[3];
 bytTotalHi = aryBuffer[4];
 bytTotalLo = aryBuffer[5];

 if ( aryBuffer[1] == FORCE_MULTIPLE_COILS ||
 aryBuffer[1] == PRESET_MULTIPLE_REGISTERS ) {
 uintCRCpos += 1 + aryBuffer[6];
 }

 uintCRC = calcCRC(uintCRCpos);

 if ( (uintCRC & 0xff) == aryBuffer[uintCRCpos] &&
 (uintCRC >> 0x08) == aryBuffer[uintCRCpos + 1] ) {

 uint uintSAddr, uintEAddr, uintItemCount, uintLength = 6;
 uint uintOffset, uintAddr, uintBit;
 discreteDef* pDiscretes;
 registerDef* pRegisters;

 uintSAddr = (((uint)bytStartHi << 0x08) | bytStartLo) + 1;

 uintItemCount = ((uint)bytTotalHi << 0x08) | bytTotalLo;

 uintEAddr = uintSAddr + uintItemCount - 1;

 switch( aryBuffer[1] ) {
 case READ_COILS:
 case READ_STATUS_INPUTS:
 if ( aryBuffer[1] == READ_COILS ) {
 pDiscretes = pCoils;
 } else {
 pDiscretes = pStatusBits;
 }
 if ( (uintEAddr - uintSAddr + 1) >  2000  ||
 validDiscretes(pDiscretes, uintSAddr, uintEAddr) == FALSE ) {
 exceptionCode = ILLEGAL_DATA_ADDRESS;

 } else {
 aryBuffer[2] = packBits(pDiscretes,
 &aryBuffer[3],
 uintSAddr, uintEAddr);
 uintLength = aryBuffer[2] + 3;
 }
 break;
 case READ_HOLDING_REGISTERS:
 case READ_INPUT_REGISTERS:
 if ( aryBuffer[1] == READ_INPUT_REGISTERS ) {
 pRegisters = pInputs;
 } else {
 pRegisters = pHoldingRegs;
 }
 if ( (uintEAddr - uintSAddr + 1) >  125  ||
 validRegisters(pRegisters, uintSAddr, uintEAddr) == FALSE ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 aryBuffer[2] = packRegisters(pRegisters,
 &aryBuffer[3],
 uintSAddr, uintEAddr);
 uintLength = aryBuffer[2] + 3;
 }
 break;
 case FORCE_SINGLE_COIL:
 if ( validDiscretes(pCoils, uintSAddr, uintSAddr) == FALSE ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 if ( aryBuffer[4] == 0xff && aryBuffer[5] == 0x0 ) {

 coilState(uintSAddr, TRUE);
 } else if ( aryBuffer[4] == 0x0 && aryBuffer[5] == 0x0 ) {

 coilState(uintSAddr, FALSE);
 }
 }
 break;
 case PRESET_SINGLE_REGISTER:
 if ( validRegisters(pHoldingRegs, uintSAddr, uintSAddr) == FALSE ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 } else {
 setRegister(uintSAddr, (uint*)&aryBuffer[4]);
 }
 break;
 case FORCE_MULTIPLE_COILS:
 if ( uintItemCount >  1968  ||
 uintItemCount > (aryBuffer[6] * 8) ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 break;
 }
 case PRESET_MULTIPLE_REGISTERS:
 if ( (aryBuffer[1] == PRESET_MULTIPLE_REGISTERS &&
 uintItemCount >  123 ) ) {

 exceptionCode = ILLEGAL_DATA_ADDRESS;
 } else if ( validDiscretes(pCoils,
 uintSAddr, uintEAddr) == FALSE ) {
 aryBuffer[1] |=  0x80 ;
 } else {
 uintOffset = 0;
 uintAddr = uintSAddr;

 while( uintAddr<=uintEAddr ) {
 if ( aryBuffer[1] == PRESET_MULTIPLE_REGISTERS ) {
 setRegister(uintAddr,
 (uint*)&aryBuffer[7 + uintOffset]);
 uintOffset += 2;
 } else {
 for(uintBit=0; uintBit<8; uintBit++, uintAddr++ ) {
 coilState(uintAddr,
 aryBuffer[7 + uintOffset] & (1 << uintBit));
 }
 uintOffset++;
 }
 uintAddr++;
 }
 }
 break;
 }
 if( exceptionCode != NO_EXCEPTION ) {
 aryBuffer[1] |=  0x80 ;
 aryBuffer[2] = (byte)exceptionCode;
 exceptionCode = NO_EXCEPTION;
 uintLength = 3;
 }
 if ( uintLength > 0 ) {

 uintCRC = calcCRC(uintLength);
 aryBuffer[uintLength] = (uintCRC & 0xff);
 uintLength++;
 aryBuffer[uintLength] = (uintCRC >> 0x08);
 uintLength++;

 CREN_bit = 0;
 RCIE_bit = 0;

 TXEN_bit = 1;
 Tx_dir = 1;

 bytRxphase = 128;

 TXREG = bytSlaveAddress;

 aryBuffer[0] = uintLength;
 bytIndex = 2;

 while( !TXIF_bit ){}
 TXREG = aryBuffer[1];

 TXIE_bit = 1;
 return;
 }
 }
 }

 bytIndex = 0;
 bytRxphase = 1;
}
#line 812 "F:/MikroC/ModbusSlave/ModbusSlave.c"
int modbusSlave(baudRate eBaud, const byte bytAddress, const byte bytStopBits) {
 long lngTimeoutPreset;
 byte bytTemp;

 if ( bytAddress < 1 || bytAddress > 247 ) {
 return -1;
 }

 memset(aryBuffer, 0, sizeof(aryBuffer));

 bytSlaveAddress = bytAddress;

 uintRxGap = 0;

 exceptionCode = NO_EXCEPTION;

 switch( eBaud ) {
 case BAUD_1200:
 UART1_Init(BAUD_1200 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_1200)) ;
 break;
 case BAUD_2400:
 UART1_Init(BAUD_2400 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_2400)) ;
 break;
 case BAUD_4800:
 UART1_Init(BAUD_4800 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_4800)) ;
 break;
 case BAUD_9600:
 UART1_Init(BAUD_9600 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_9600)) ;
 break;
 case BAUD_19200:
 UART1_Init(BAUD_19200 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_19200)) ;
 break;
 case BAUD_38400:
 UART1_Init(BAUD_38400 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_38400)) ;
 break;
 case BAUD_57600:
 UART1_Init(BAUD_57600 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_57600)) ;
 break;
 case BAUD_115200:
 UART1_Init(BAUD_115200 * 100);
 lngTimeoutPreset =  (long)( 2 *110*Clock_kHz()/(4*BAUD_115200)) ;
 break;
 default:
 return -1;
 }

 Delay_ms(100);



 T0CON.TMR0ON = 0;
 T0CON.T08BIT = 0;
 T0CON.T0CS = 0;
 T0CON.T0SE = 0;
 T0CON.PSA = 1;
 T0CON.T0PS2 = 0;
 T0CON.T0PS1 = 0;
 T0CON.T0PS0 = 0;

 bytTemp = 0;
 while( lngTimeoutPreset > 29126 ) {
 lngTimeoutPreset >>= 1;
 bytTemp++;
 }
 if ( bytTemp > 0 && bytTemp <= 8 ) {
 T0CON.PSA = 0;
 T0CON = T0CON | (--bytTemp & 0x07);
 }
 uintRxGapSetPt1 = (uint)-(lngTimeoutPreset >> 1);
 uintRxGapSetPt2 = (uint)-lngTimeoutPreset;
 uintRxGapSetPt3 = (uint)-(lngTimeoutPreset*5 >> 2);
 uintRxGapSetPt = (uint)-(lngTimeoutPreset*9 >> 2);

 if ( bytStopBits != 1 ) {
 TX9_bit=1;
 TX9D_bit=1;
 }


 restartRx();
 TMR0IE_bit = 1;

 PEIE_bit = 1;

 GIE_bit = 1;
}
