#line 1 "F:/MikroC/ModbusSlave/main.c"
#line 1 "f:/mikroc/modbusslave/modbusslave.h"
#line 1 "f:/mikroc/modbusslave/types.h"
#line 14 "f:/mikroc/modbusslave/types.h"
 typedef unsigned long ulong;


 typedef unsigned int uint;


 typedef unsigned short ushort;


 typedef unsigned char byte;


 typedef enum ebool { FALSE, TRUE } boolean;
#line 41 "f:/mikroc/modbusslave/modbusslave.h"
 typedef struct {
 byte bytHi;
 byte bytLo;
 } hiloDef;

 typedef enum eBaudRates {
 BAUD_1200 = 12,
 BAUD_2400 = 24,
 BAUD_4800 = 48,
 BAUD_9600 = 96,
 BAUD_19200 = 192,
 BAUD_38400 = 384,
 BAUD_57600 = 576,
 BAUD_115200 = 1152
 } baudRate;

 typedef enum eModbusFunctions {
 READ_COILS = 1,
 READ_STATUS_INPUTS = 2,
 READ_HOLDING_REGISTERS = 3,
 READ_INPUT_REGISTERS = 4,
 FORCE_SINGLE_COIL = 5,
 PRESET_SINGLE_REGISTER = 6,
 FORCE_MULTIPLE_COILS = 15,
 PRESET_MULTIPLE_REGISTERS = 16
 } mbFunction;

 typedef enum eModbusExceptions {
 NO_EXCEPTION = 0,
 ILLEGAL_FUNCTION = 1,
 ILLEGAL_DATA_ADDRESS = 2,
 ILLEGAL_DATA_VALUE = 3,
 SLAVE_DEVICE_FAILURE = 4,
 ACKNOWLEDGE = 5,
 SLAVE_DEVICE_BUSY = 6,
 NEGATIVE_ACKNOWLEDGE = 7,
 MEMORY_PARITY_ERROR = 8
 } mbException;

 typedef struct _discrete {

 uint uintAddress;

 ushort* pByte;

 byte bBit;

 struct _discrete* pNext;
 } discreteDef;

 typedef discreteDef coilDef;
 typedef discreteDef statusDef;


 typedef struct {
 byte bytSlave;
 byte bytFunction;
 hiloDef addr;
 hiloDef points;
 hiloDef crc;
 } reqDataDef;

 typedef reqDataDef reqCoilsDef;
 typedef reqDataDef reqStatusDef;
 typedef reqDataDef reqHoldReqDef;
 typedef reqDataDef reqInputsDef;

 typedef struct _register {

 uint uintAddress;

 union {
 byte* pLoHi[2];
 uint* pBase;
 } mapping;

 struct _register* pNext;
 } registerDef;

 typedef registerDef inputDef;
 typedef registerDef holdingDef;

 boolean addCoil(coilDef* pCoil,
 uint uintAddress, ushort* pByte, byte bBit);
 boolean addHoldingReg(holdingDef* pHolding,
 uint uintAddress, byte bytMapping, uint* pWord);
 boolean addInputReg(inputDef* pInput,
 uint uintAddress, byte bytMapping, uint* pWord);
 boolean addStatusBit(statusDef* pStatus,
 uint uintAddress, ushort* pByte, byte bBit);
 void decodePacket(void);
 int modbusSlave(baudRate eBaud, const byte bytAddress,
 const byte bytStopBits);

 extern sfr sbit Tx_dir;
#line 22 "F:/MikroC/ModbusSlave/main.c"
static statusDef statusBits[28];
static holdingDef holdingReg[2];
static inputDef inputReg[2];
static coilDef coils[20];
#line 29 "F:/MikroC/ModbusSlave/main.c"
void interrupt() {
 decodePacket();
}
#line 35 "F:/MikroC/ModbusSlave/main.c"
void main() {
 int p, i;

 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 ANSELE = 0;
#line 48 "F:/MikroC/ModbusSlave/main.c"
 TRISA = 0;
 TRISB = 0;
 TRISC = 0;
 TRISE = 0;

 TRISD = 0xff;

 LATA = 0;
 LATB = 0;
 LATC = 0;
 LATE = 0;

 memset(statusBits, 0, sizeof(statusBits));
 memset(holdingReg, 0, sizeof(holdingReg));
 memset(inputReg, 0, sizeof(inputReg));
 memset(coils, 0, sizeof(coils));

 modbusSlave(BAUD_115200, 1, 1);
 i = 0;
 for( p=0; p<8; p++, i++ ) {
 addCoil(&coils[i], i + 1, &LATB, p);
 }
 for( p=0; p<8; p++, i++ ) {
 addCoil(&coils[i], i + 1, &LATC, p);
 }
 for( p=0; p<4; p++, i++ ) {
 addCoil(&coils[i], i + 1, &LATE, p);
 }
 i = 0;
 for( p=0; p<8; p++, i++ ) {
 addStatusBit(&statusBits[i], i + 1, &PORTB, p);
 }
 for( p=0; p<8; p++, i++ ) {
 addStatusBit(&statusBits[i], i + 1, &PORTC, p);
 }
 for( p=0; p<8; p++, i++ ) {
 addStatusBit(&statusBits[i], i + 1, &PORTD, p);
 }
 for( p=0; p<4; p++, i++ ) {
 addStatusBit(&statusBits[i], i + 1, &PORTE, p);
 }
 addInputReg(&inputReg[0], 1, 0, (uint*)&PORTB);
 addInputReg(&inputReg[0], 1, 1, (uint*)&PORTC);
 addInputReg(&inputReg[1], 2, 0, (uint*)&PORTD);
 addInputReg(&inputReg[1], 2, 1, (uint*)&PORTE);
 addHoldingReg(&holdingReg[0], 1, 0, (uint*)&PORTB);
 addHoldingReg(&holdingReg[0], 1, 1, (uint*)&PORTC);
 addHoldingReg(&holdingReg[1], 2, 0, (uint*)&PORTE);

 while (1) {
 }
}
